------------------------------------------------------
-- LogiBLOX ROM Module "bullet"
-- Created by LogiBLOX version D.24
--    on Thu Mar 08 18:44:38 2001
-- Attributes 
--    MODTYPE = ROM
--    BUS_WIDTH = 3
--    DEPTH = 64
--    MEMFILE = bulletrom
--    TRIM = FALSE
--    STYLE = MAX_SPEED
--    USE_RPM = FALSE
------------------------------------------------------
-- This is a behaviorial model only and cannot be synthesized.
------------------------------------------------------
LIBRARY IEEE;
USE IEEE.std_logic_1164.ALL;

-- synopsys translate_off
LIBRARY logiblox;
USE logiblox.mvlutil.ALL;
USE logiblox.mvlarith.ALL;
USE logiblox.logiblox.ALL;
-- synopsys translate_on

ENTITY bullet IS
  PORT(
    A: IN std_logic_vector(5 DOWNTO 0);
    DO: OUT std_logic_vector(2 DOWNTO 0));
END bullet;

-- synopsys translate_off
ARCHITECTURE sim OF bullet IS
  SIGNAL START_PULSE: std_logic := '1';
  TYPE mem_data IS ARRAY (63 DOWNTO 0) OF std_logic_vector(2 DOWNTO 0);
BEGIN
  PROCESS
  VARIABLE VD: mem_data;
  VARIABLE first_time: BOOLEAN := TRUE;
  BEGIN
    IF (first_time) THEN
      VD(0) := ('0','0','0');
      VD(1) := ('1','1','1');
      VD(2) := ('1','1','1');
      VD(3) := ('1','1','1');
      VD(4) := ('1','1','1');
      VD(5) := ('1','1','1');
      VD(6) := ('1','1','1');
      VD(7) := ('0','0','0');
      VD(8) := ('1','1','1');
      VD(9) := ('0','0','0');
      VD(10) := ('0','1','1');
      VD(11) := ('0','1','1');
      VD(12) := ('0','1','1');
      VD(13) := ('0','1','1');
      VD(14) := ('0','0','0');
      VD(15) := ('1','1','1');
      VD(16) := ('1','1','1');
      VD(17) := ('1','0','1');
      VD(18) := ('0','0','0');
      VD(19) := ('0','1','1');
      VD(20) := ('0','1','1');
      VD(21) := ('0','0','0');
      VD(22) := ('1','0','0');
      VD(23) := ('1','1','1');
      VD(24) := ('1','1','1');
      VD(25) := ('1','0','1');
      VD(26) := ('1','0','1');
      VD(27) := ('0','0','0');
      VD(28) := ('0','0','0');
      VD(29) := ('1','0','0');
      VD(30) := ('1','0','0');
      VD(31) := ('1','1','1');
      VD(32) := ('1','1','1');
      VD(33) := ('1','0','1');
      VD(34) := ('1','0','1');
      VD(35) := ('0','0','0');
      VD(36) := ('0','0','0');
      VD(37) := ('1','0','0');
      VD(38) := ('1','0','0');
      VD(39) := ('1','1','1');
      VD(40) := ('1','1','1');
      VD(41) := ('1','0','1');
      VD(42) := ('0','0','0');
      VD(43) := ('1','1','0');
      VD(44) := ('1','1','0');
      VD(45) := ('0','0','0');
      VD(46) := ('1','0','0');
      VD(47) := ('1','1','1');
      VD(48) := ('1','1','1');
      VD(49) := ('0','0','0');
      VD(50) := ('1','1','0');
      VD(51) := ('1','1','0');
      VD(52) := ('1','1','0');
      VD(53) := ('1','1','0');
      VD(54) := ('0','0','0');
      VD(55) := ('1','1','1');
      VD(56) := ('0','0','0');
      VD(57) := ('1','1','1');
      VD(58) := ('1','1','1');
      VD(59) := ('1','1','1');
      VD(60) := ('1','1','1');
      VD(61) := ('1','1','1');
      VD(62) := ('1','1','1');
      VD(63) := ('0','0','0');
      first_time := FALSE;
    END IF;
    IF (mvlvec_not01(A)) THEN
      DO <= ('X','X','X');
    ELSIF (mvlvec2int(A) > 63) THEN
      ASSERT (FALSE)
      REPORT "The value on the address line is out of range"
      SEVERITY WARNING;
      DO <= ('X','X','X');
    ELSE
      DO <= VD(mvlvec2int(A));
    END IF;
      WAIT ON A, START_PULSE;
  END PROCESS;
END sim;
-- synopsys translate_on
