------------------------------------------------------
-- LogiBLOX ROM Module "car11"
-- Created by LogiBLOX version D.24
--    on Sat Mar 03 12:02:17 2001
-- Attributes 
--    MODTYPE = ROM
--    BUS_WIDTH = 4
--    DEPTH = 128
--    MEMFILE = car11
--    TRIM = FALSE
--    STYLE = MAX_SPEED
--    USE_RPM = FALSE
------------------------------------------------------
-- This is a behaviorial model only and cannot be synthesized.
------------------------------------------------------
LIBRARY IEEE;
USE IEEE.std_logic_1164.ALL;

-- synopsys translate_off
LIBRARY logiblox;
USE logiblox.mvlutil.ALL;
USE logiblox.mvlarith.ALL;
USE logiblox.logiblox.ALL;
-- synopsys translate_on

ENTITY car11 IS
  PORT(
    A: IN std_logic_vector(6 DOWNTO 0);
    DO: OUT std_logic_vector(3 DOWNTO 0));
END car11;

-- synopsys translate_off
ARCHITECTURE sim OF car11 IS
  SIGNAL START_PULSE: std_logic := '1';
  TYPE mem_data IS ARRAY (127 DOWNTO 0) OF std_logic_vector(3 DOWNTO 0);
BEGIN
  PROCESS
  VARIABLE VD: mem_data;
  VARIABLE first_time: BOOLEAN := TRUE;
  BEGIN
    IF (first_time) THEN
      VD(0) := ('1','1','0','0');
      VD(1) := ('1','1','0','0');
      VD(2) := ('1','1','0','0');
      VD(3) := ('1','1','0','0');
      VD(4) := ('1','1','0','0');
      VD(5) := ('1','0','0','1');
      VD(6) := ('0','0','0','0');
      VD(7) := ('0','0','0','0');
      VD(8) := ('1','1','0','0');
      VD(9) := ('1','1','0','0');
      VD(10) := ('1','1','0','0');
      VD(11) := ('1','1','0','0');
      VD(12) := ('1','1','0','0');
      VD(13) := ('1','0','0','1');
      VD(14) := ('0','0','0','0');
      VD(15) := ('0','0','0','0');
      VD(16) := ('1','1','0','0');
      VD(17) := ('1','1','0','0');
      VD(18) := ('1','1','0','0');
      VD(19) := ('1','1','0','0');
      VD(20) := ('1','1','0','0');
      VD(21) := ('1','0','0','1');
      VD(22) := ('0','0','0','0');
      VD(23) := ('0','0','0','0');
      VD(24) := ('1','0','0','1');
      VD(25) := ('1','1','0','0');
      VD(26) := ('1','0','0','1');
      VD(27) := ('1','1','0','0');
      VD(28) := ('1','0','0','1');
      VD(29) := ('1','0','0','1');
      VD(30) := ('0','0','0','0');
      VD(31) := ('0','0','0','0');
      VD(32) := ('1','1','0','0');
      VD(33) := ('1','0','0','1');
      VD(34) := ('1','1','0','0');
      VD(35) := ('1','0','0','1');
      VD(36) := ('1','0','0','1');
      VD(37) := ('0','0','0','0');
      VD(38) := ('0','0','0','0');
      VD(39) := ('0','0','0','0');
      VD(40) := ('1','0','0','1');
      VD(41) := ('1','1','0','0');
      VD(42) := ('1','0','0','1');
      VD(43) := ('1','1','0','0');
      VD(44) := ('1','0','0','1');
      VD(45) := ('0','0','0','0');
      VD(46) := ('1','0','0','1');
      VD(47) := ('1','0','0','1');
      VD(48) := ('1','1','0','0');
      VD(49) := ('1','0','0','1');
      VD(50) := ('1','1','0','0');
      VD(51) := ('1','0','0','1');
      VD(52) := ('1','0','0','1');
      VD(53) := ('0','0','0','0');
      VD(54) := ('1','0','0','1');
      VD(55) := ('1','0','0','1');
      VD(56) := ('1','0','0','1');
      VD(57) := ('1','1','0','0');
      VD(58) := ('1','0','0','1');
      VD(59) := ('1','1','0','0');
      VD(60) := ('1','0','0','1');
      VD(61) := ('1','0','0','1');
      VD(62) := ('1','0','0','1');
      VD(63) := ('1','0','0','1');
      VD(64) := ('1','1','0','0');
      VD(65) := ('1','0','0','1');
      VD(66) := ('1','1','0','0');
      VD(67) := ('1','0','0','1');
      VD(68) := ('1','0','0','1');
      VD(69) := ('1','0','0','1');
      VD(70) := ('1','0','0','1');
      VD(71) := ('1','0','0','1');
      VD(72) := ('1','0','0','1');
      VD(73) := ('1','1','0','0');
      VD(74) := ('1','0','0','1');
      VD(75) := ('1','1','0','0');
      VD(76) := ('1','0','0','1');
      VD(77) := ('0','0','0','0');
      VD(78) := ('1','0','0','1');
      VD(79) := ('1','0','0','1');
      VD(80) := ('1','1','0','0');
      VD(81) := ('1','0','0','1');
      VD(82) := ('1','1','0','0');
      VD(83) := ('1','0','0','1');
      VD(84) := ('1','0','0','1');
      VD(85) := ('0','0','0','0');
      VD(86) := ('1','0','0','1');
      VD(87) := ('1','0','0','1');
      VD(88) := ('1','0','0','1');
      VD(89) := ('1','1','0','0');
      VD(90) := ('1','0','0','1');
      VD(91) := ('1','1','0','0');
      VD(92) := ('1','0','0','1');
      VD(93) := ('0','0','0','0');
      VD(94) := ('0','0','0','0');
      VD(95) := ('0','0','0','0');
      VD(96) := ('1','1','0','0');
      VD(97) := ('1','1','0','0');
      VD(98) := ('1','1','0','0');
      VD(99) := ('1','1','0','0');
      VD(100) := ('1','0','0','1');
      VD(101) := ('1','0','0','1');
      VD(102) := ('0','0','0','0');
      VD(103) := ('0','0','0','0');
      VD(104) := ('1','1','0','0');
      VD(105) := ('1','1','0','0');
      VD(106) := ('1','1','0','0');
      VD(107) := ('1','1','0','0');
      VD(108) := ('1','1','0','0');
      VD(109) := ('1','0','0','1');
      VD(110) := ('1','0','0','1');
      VD(111) := ('0','0','0','0');
      VD(112) := ('1','0','0','1');
      VD(113) := ('1','1','0','0');
      VD(114) := ('1','0','0','1');
      VD(115) := ('1','1','0','0');
      VD(116) := ('1','0','0','1');
      VD(117) := ('1','1','0','0');
      VD(118) := ('1','0','0','1');
      VD(119) := ('0','0','0','0');
      VD(120) := ('1','0','0','1');
      VD(121) := ('1','0','0','1');
      VD(122) := ('1','0','0','1');
      VD(123) := ('1','0','0','1');
      VD(124) := ('1','0','0','1');
      VD(125) := ('1','0','0','1');
      VD(126) := ('1','0','0','1');
      VD(127) := ('0','0','0','0');
      first_time := FALSE;
    END IF;
    IF (mvlvec_not01(A)) THEN
      DO <= ('X','X','X','X');
    ELSIF (mvlvec2int(A) > 127) THEN
      ASSERT (FALSE)
      REPORT "The value on the address line is out of range"
      SEVERITY WARNING;
      DO <= ('X','X','X','X');
    ELSE
      DO <= VD(mvlvec2int(A));
    END IF;
      WAIT ON A, START_PULSE;
  END PROCESS;
END sim;
-- synopsys translate_on
