------------------------------------------------------
-- LogiBLOX COMPARE Module "cmpgt455"
-- Created by LogiBLOX version D.24
--    on Wed Mar 07 21:36:37 2001
-- Attributes 
--    MODTYPE = COMPARE
--    BUS_WIDTH = 9
--    C_VALUE = 455
--    STYLE = MAX_SPEED
--    ENCODING = UNSIGNED
------------------------------------------------------
-- This is a behaviorial model only and cannot be synthesized.
------------------------------------------------------
LIBRARY IEEE;
USE IEEE.std_logic_1164.ALL;

-- synopsys translate_off
LIBRARY logiblox;
USE logiblox.mvlutil.ALL;
USE logiblox.mvlarith.ALL;
USE logiblox.logiblox.ALL;
-- synopsys translate_on

ENTITY cmpgt455 IS
  PORT(
    A: IN std_logic_vector(8 DOWNTO 0);
    A_GT_B: OUT std_logic);
END cmpgt455;

-- synopsys translate_off
ARCHITECTURE sim OF cmpgt455 IS
    SIGNAL START_PULSE: std_logic := '1';
BEGIN
  PROCESS
    VARIABLE VA: std_logic_vector(8 DOWNTO 0);
    VARIABLE VB: std_logic_vector(8 DOWNTO 0);
    VARIABLE VA_EQ_B: std_logic;
    VARIABLE VA_NE_B: std_logic;
    VARIABLE VA_LT_B: std_logic;
    VARIABLE VA_GT_B: std_logic;
    VARIABLE VA_LE_B: std_logic;
    VARIABLE VA_GE_B: std_logic;
    BEGIN
      VA := stdvec2mvl(A);
      VB := ('1','1','1','0','0','0','1','1','1');
      xb_compare(
          VA,
          VB,
          UNSIGNED,
          VA_EQ_B,
          VA_NE_B,
          VA_LT_B,
          VA_GE_B,
          VA_GT_B,
          VA_LE_B);
      A_GT_B <= VA_GT_B;
      IF (START_PULSE='1') THEN
        START_PULSE <= '0' AFTER 1 ns;
      END IF;
      WAIT ON A, START_PULSE;
  END PROCESS;
END sim;
-- synopsys translate_on
