module translator(NK, scancode, NI, instr);

input NK;
input [7:0] scancode;
output NI;
output [15:0] instr;

reg NI;
reg [15:0] instr;

reg [1:0] count;

always @ (posedge NK) begin

  case (scancode)
    // Push the number
    8'h70, 8'h69, 8'h72, 8'h7A, 8'h6B, 8'h73, 8'h74, 8'h6C, 8'h75, 8'h7D,
    8'h45, 8'h16, 8'h1E, 8'h26, 8'h25, 8'h2E, 8'h36, 8'h3D, 8'h3E, 8'h46:  begin
      // do the opcode
      instr[15:12] <= 4'hF;
      // copy the data and assert the NI when we got all 3 input numbers
      if (count == 0) instr[11:8] <= scancode;
      else if (count == 1) instr[8:5] <= scancode;
      else if (count == 2) begin
        instr[4:0] <= scancode;
        NI <= 1;
      end
      // update the count
      if (count < 2) count <= count + 1;
      else count <= 0;
    end
    8'h79:  begin // add 
      instr[15:12] <= 4'h8;
      instr[11:0] <= 0;
      NI <= 1;
    end
    8'h7B:  begin // subtract
      instr[15:12] <= 4'h9;
      instr[11:0] <= 0;
      NI <= 1;
    end
    8'h7C:  begin // multiply
      instr[15:12] <= 4'hA;
      instr[11:0] <= 0;
      NI <= 1;
    end 
  endcase
end

endmodule     
			

