module KBD_CTL (KBD_IN, KBD_EN, CLK, ESC_OUT, X1, Y1, X2, Y2) ;

input [7:0]KBD_IN;
input KBD_EN;
input CLK;
output [9:0]X1, Y1, X2, Y2;
output ESC_OUT;

reg [9:0]X1, Y1, X2, Y2;
reg [1:0]state;
reg ESC_OUT;

always @(posedge CLK) begin
  ESC_OUT <= 0;
  
  if(KBD_EN && !state)begin
    state <= 1;
  end
  if(!KBD_EN && state) begin
    state <= 0;
  end

  
  if(state == 1) begin
    state <= 2;
    if(KBD_IN == 'h6B) begin
      X1 <= (X1 > 4) ? (X1 - 5) : 0;
      X2 <= (X1 > 4) ? (X1 + 55) : 60;
    end
    if(KBD_IN == 'h74) begin
      X1 <= (X2 < 636) ? (X1 + 5) : 580;
      X2 <= (X2 < 636) ? (X1 + 65) : 640;
    end
    if(KBD_IN == 'h76) begin
      X1 <= 35;
      Y1 <= 400;
      X2 <= 85;
      Y2 <= 410;
      ESC_OUT <= 1;
    end
  end


end
endmodule 
