module mainctrl (clk, reset, VRGB, newBullet, noValid, 
		 movePlayers,
		 addBullet, addBulletvx, addBulletvy, updateBullets) ;

input clk ;
input reset ;
input VRGB;
input newBullet;
input noValid ;
output addBullet ;
output [3:0] addBulletvx ;
output [3:0] addBulletvy ;
output updateBullets ;
output movePlayers ;

reg _addBullet;
assign addBullet = _addBullet;
reg [3:0] _addBulletvx;
assign addBulletvx = _addBulletvx;
reg [3:0] _addBulletvy;
assign addBulletvy = _addBulletvy;
reg _updateBullets;
assign updateBullets = _updateBullets;
reg _movePlayers;
assign movePlayers = _movePlayers;

reg insertNewBullet;

//_pseudo_ random number generator
reg [2:0] rand;

reg [10:0] cycleno;
reg VRGBPREV;
reg startUpdate;
reg startState;
//assert the start signal to the controller
always@(posedge clk) begin
	VRGBPREV <= VRGB;
	if(VRGB & !VRGBPREV)
		startUpdate <= 1;
	else
		startUpdate <= 0;
		
	rand <= rand +1;		
end

always@(posedge clk) begin

	if(reset) begin
		_movePlayers <= 0;
		_addBullet <= 0;
		_updateBullets <= 0;
		startState <= 1;
		cycleno <= 0;
		insertNewBullet <= 0;
	end
	else begin
		_movePlayers <= 0;
		_addBullet <= 0;
		_updateBullets<= 0;
		if(startState & startUpdate) begin
			_addBullet <= 1;
			if(rand[0])
				_addBulletvx <= 4'b0001;
			else
				_addBulletvx <= 4'b1111;
			if(rand[1] & rand[2])
				_addBulletvy <= 4'b0001;
			else if(rand[1] & !rand[2])
				_addBulletvy <= 4'b1111;
			else _addBulletvy <= 4'b0000;

			_movePlayers <= 1;
			cycleno <= 0;
			startState <= 0;
		end
		else if(startUpdate) begin
			_movePlayers <= 1;
			cycleno <= 1;
		end 
		else if(cycleno >0 & cycleno < 10) begin
			cycleno <= cycleno +1;
		end
		else if(cycleno == 10) begin
			_updateBullets <= 1;
			cycleno <=cycleno +1;
		end
		else if(cycleno >10 & cycleno <30) begin
			cycleno <= cycleno +1;
			if(newBullet)
				insertNewBullet <= 1;
		end
		else if(cycleno == 30) begin
			cycleno <= 0;
			if (insertNewBullet | noValid) begin
				_addBullet <= 1;
				if(rand[0])
					_addBulletvx <= 4'b0001;
				else
					_addBulletvx <= 4'b1111;
				if(rand[1] & rand[2])
					_addBulletvy <= 4'b0001;
				else if(rand[1] & !rand[2])
					_addBulletvy <= 4'b1111;
				else _addBulletvy <= 4'b0000;
			end
			insertNewBullet <= 0;			
		end		
	end
end

endmodule 
