module UPDATEPOS (clk, X, Y, VX, VY, OLDX, NEWX, NEWY, NEWVX, NEWVY, died, OUTLEFT, OUTRIGHT) ;


input clk ;
input [9:0] X ;
input [8:0] Y ;
input [3:0] VX ;
input [3:0] VY ;
output [9:0] OLDX ;
output [9:0] NEWX ;
output [8:0] NEWY ;
output [3:0] NEWVX ;
output [3:0] NEWVY ;
output died;
output OUTLEFT;
output OUTRIGHT;

reg [9:0] _OLDX;
assign OLDX = _OLDX;

reg [9:0] _NEWX;
reg [8:0] _NEWY;
assign NEWX = _NEWX;
assign NEWY = _NEWY;

reg [3:0] _NEWVX;
reg [3:0] _NEWVY;
assign NEWVX = _NEWVX;
assign NEWVY = _NEWVY;

reg _died;
assign died = _died;

reg _OUTLEFT;
assign OUTLEFT = _OUTLEFT;
reg _OUTRIGHT;
assign OUTRIGHT = _OUTRIGHT;

//updates position of a object, assuming 
//nothing about it's coordninaties. Only adds velocity to position
always@(posedge clk) begin
	_OUTLEFT <= 0;
	_OUTRIGHT <= 0;	
	_died <= 0;
	_OLDX <= X;
	//update to new position
	_NEWX = X + {VX[3],VX[3],VX[3],VX[3],VX[3],VX[3],VX};
	_NEWY = Y + {VY[3],VY[3],VY[3],VY[3],VY[3],VY};
	_NEWVX <= VX;
	_NEWVY <= VY;
	//avoid the walls, adjust new position & speed
	if(_NEWY < 10) begin
		_NEWY = Y;
		_NEWVY <= ~VY +1;
	end
	else if(_NEWY > 442) begin
		_NEWY = Y;
		_NEWVY <= ~VY +1;
	end
	if(_NEWX < 0 |_NEWX >639)
		_died <= 1;
	if(_NEWX > 1000)
		_OUTLEFT <= 1;
	else if(_NEWX > 639)
		_OUTRIGHT <= 1;
end

endmodule 
